#[doc = r" Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - CAN_MCR"]
    pub can_mcr: CAN_MCR,
    #[doc = "0x04 - CAN_MSR"]
    pub can_msr: CAN_MSR,
    #[doc = "0x08 - CAN_TSR"]
    pub can_tsr: CAN_TSR,
    #[doc = "0x0c - CAN_RF0R"]
    pub can_rf0r: CAN_RF0R,
    #[doc = "0x10 - CAN_RF1R"]
    pub can_rf1r: CAN_RF1R,
    #[doc = "0x14 - CAN_IER"]
    pub can_ier: CAN_IER,
    #[doc = "0x18 - CAN_ESR"]
    pub can_esr: CAN_ESR,
    #[doc = "0x1c - CAN_BTR"]
    pub can_btr: CAN_BTR,
    _reserved0: [u8; 352usize],
    #[doc = "0x180 - CAN_TI0R"]
    pub can_ti0r: CAN_TI0R,
    #[doc = "0x184 - CAN_TDT0R"]
    pub can_tdt0r: CAN_TDT0R,
    #[doc = "0x188 - CAN_TDL0R"]
    pub can_tdl0r: CAN_TDL0R,
    #[doc = "0x18c - CAN_TDH0R"]
    pub can_tdh0r: CAN_TDH0R,
    #[doc = "0x190 - CAN_TI1R"]
    pub can_ti1r: CAN_TI1R,
    #[doc = "0x194 - CAN_TDT1R"]
    pub can_tdt1r: CAN_TDT1R,
    #[doc = "0x198 - CAN_TDL1R"]
    pub can_tdl1r: CAN_TDL1R,
    #[doc = "0x19c - CAN_TDH1R"]
    pub can_tdh1r: CAN_TDH1R,
    #[doc = "0x1a0 - CAN_TI2R"]
    pub can_ti2r: CAN_TI2R,
    #[doc = "0x1a4 - CAN_TDT2R"]
    pub can_tdt2r: CAN_TDT2R,
    #[doc = "0x1a8 - CAN_TDL2R"]
    pub can_tdl2r: CAN_TDL2R,
    #[doc = "0x1ac - CAN_TDH2R"]
    pub can_tdh2r: CAN_TDH2R,
    #[doc = "0x1b0 - CAN_RI0R"]
    pub can_ri0r: CAN_RI0R,
    #[doc = "0x1b4 - CAN_RDT0R"]
    pub can_rdt0r: CAN_RDT0R,
    #[doc = "0x1b8 - CAN_RDL0R"]
    pub can_rdl0r: CAN_RDL0R,
    #[doc = "0x1bc - CAN_RDH0R"]
    pub can_rdh0r: CAN_RDH0R,
    #[doc = "0x1c0 - CAN_RI1R"]
    pub can_ri1r: CAN_RI1R,
    #[doc = "0x1c4 - CAN_RDT1R"]
    pub can_rdt1r: CAN_RDT1R,
    #[doc = "0x1c8 - CAN_RDL1R"]
    pub can_rdl1r: CAN_RDL1R,
    #[doc = "0x1cc - CAN_RDH1R"]
    pub can_rdh1r: CAN_RDH1R,
}
#[doc = "CAN_MCR"]
pub struct CAN_MCR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_MCR"]
pub mod can_mcr;
#[doc = "CAN_MSR"]
pub struct CAN_MSR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_MSR"]
pub mod can_msr;
#[doc = "CAN_TSR"]
pub struct CAN_TSR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_TSR"]
pub mod can_tsr;
#[doc = "CAN_RF0R"]
pub struct CAN_RF0R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_RF0R"]
pub mod can_rf0r;
#[doc = "CAN_RF1R"]
pub struct CAN_RF1R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_RF1R"]
pub mod can_rf1r;
#[doc = "CAN_IER"]
pub struct CAN_IER {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_IER"]
pub mod can_ier;
#[doc = "CAN_ESR"]
pub struct CAN_ESR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_ESR"]
pub mod can_esr;
#[doc = "CAN_BTR"]
pub struct CAN_BTR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_BTR"]
pub mod can_btr;
#[doc = "CAN_TI0R"]
pub struct CAN_TI0R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_TI0R"]
pub mod can_ti0r;
#[doc = "CAN_TDT0R"]
pub struct CAN_TDT0R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_TDT0R"]
pub mod can_tdt0r;
#[doc = "CAN_TDL0R"]
pub struct CAN_TDL0R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_TDL0R"]
pub mod can_tdl0r;
#[doc = "CAN_TDH0R"]
pub struct CAN_TDH0R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_TDH0R"]
pub mod can_tdh0r;
#[doc = "CAN_TI1R"]
pub struct CAN_TI1R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_TI1R"]
pub mod can_ti1r;
#[doc = "CAN_TDT1R"]
pub struct CAN_TDT1R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_TDT1R"]
pub mod can_tdt1r;
#[doc = "CAN_TDL1R"]
pub struct CAN_TDL1R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_TDL1R"]
pub mod can_tdl1r;
#[doc = "CAN_TDH1R"]
pub struct CAN_TDH1R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_TDH1R"]
pub mod can_tdh1r;
#[doc = "CAN_TI2R"]
pub struct CAN_TI2R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_TI2R"]
pub mod can_ti2r;
#[doc = "CAN_TDT2R"]
pub struct CAN_TDT2R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_TDT2R"]
pub mod can_tdt2r;
#[doc = "CAN_TDL2R"]
pub struct CAN_TDL2R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_TDL2R"]
pub mod can_tdl2r;
#[doc = "CAN_TDH2R"]
pub struct CAN_TDH2R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_TDH2R"]
pub mod can_tdh2r;
#[doc = "CAN_RI0R"]
pub struct CAN_RI0R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_RI0R"]
pub mod can_ri0r;
#[doc = "CAN_RDT0R"]
pub struct CAN_RDT0R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_RDT0R"]
pub mod can_rdt0r;
#[doc = "CAN_RDL0R"]
pub struct CAN_RDL0R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_RDL0R"]
pub mod can_rdl0r;
#[doc = "CAN_RDH0R"]
pub struct CAN_RDH0R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_RDH0R"]
pub mod can_rdh0r;
#[doc = "CAN_RI1R"]
pub struct CAN_RI1R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_RI1R"]
pub mod can_ri1r;
#[doc = "CAN_RDT1R"]
pub struct CAN_RDT1R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_RDT1R"]
pub mod can_rdt1r;
#[doc = "CAN_RDL1R"]
pub struct CAN_RDL1R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_RDL1R"]
pub mod can_rdl1r;
#[doc = "CAN_RDH1R"]
pub struct CAN_RDH1R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CAN_RDH1R"]
pub mod can_rdh1r;
